﻿local Engine, Api, Locale, Settings = unpack(AshranBuddy)

-- Globals
array = {}

debug = function (message, ...)
	if Settings:IsDebug() then
		print("|cffffbb00" .. Engine.AddOnName .. ": |cffffffff" .. message, ...)
	end
end

table.pack = function(...)
	return { n = select("#", ...), ... }
end

array.first = function(self, func)
	for i = 1, #self do
		if (func(self[i])) then
			return self[i]
		end
	end
	return nil
end

array.select = function(self, func)
	local results = { }
	for i = 1, #self do
		local item = func(self[i])
		if (item ~= nil) then
			table.insert(results, self[i])
		end
	end
	return results
end

math.round = function(a)
	return math.floor(a + 0.5)
end

math.nearest = function(a, precision)
	return math.floor(math.round(a / precision)) * precision
end

math.roundup = function(a, precision)
	return tonumber(string.format("%." .. (precision or 0) .. "f", a))
end

string.any = function(self, array)
	for a in array do
		if (self:find(a)) then
			return true
		end
	end
	return false
end

string.lastindexof = function(self, a)
	local i = self:match(".*"..a.."()")
    if i == nil then
		return nil
	else
		return i - 1
	end
end

table.any = function(self, array)
	local any = false
	for _, a in pairs(self) do
		if (table.contains(array, a)) then
			return true
		end
	end
	return false
end

table.contains = function(self, a)
	for _, value in pairs(self) do
		if (value == a) then
			return true
		end
	end
	return false
end

table.first = function(self, func)
	for _, a in pairs(self) do
		if (func(a)) then
			return a
		end
	end
	return nil
end

table.indexof = function(self, item)
	for i = 1, #self do
		if (self[i] == item) then
			return i
		end
	end
	return -1
end

table.select = function(self, func)
	local results = { }
	for k, a in pairs(self) do
		local item = func(k, a)
		if (item ~= nil) then
			table.insert(results, item)
		end
	end
	return results
end

table.where = function(self, func)
	local results = { }
	for k, a in pairs(self) do
		if (func(a)) then
			results[k] = a
		end
	end
	return results
end